org.eclipse.viatra.query.runtime.localsearch.operations.extend

## Class ExtendPositivePatternCall

- java.lang.Object
- - org.eclipse.viatra.query.runtime.localsearch.operations.AbstractPositivePatternCallOperation
  - - org.eclipse.viatra.query.runtime.localsearch.operations.extend.ExtendPositivePatternCall

- All Implemented Interfaces:
    ISearchOperation

      public class ExtendPositivePatternCall
      extends AbstractPositivePatternCallOperation

  Since:
    1.4

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.localsearch.operations.AbstractPositivePatternCallOperation

      `call`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExtendPositivePatternCall(MatcherReference calledQuery, java.util.Map<PParameter,java.lang.Integer> frameMapping)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `execute(MatchingFrame frame, ISearchContext context)`
    `void` | `onBacktrack(MatchingFrame frame, ISearchContext context)` After the execution of the operation failed and `ISearchOperation.execute(MatchingFrame, ISearchContext)` returns false, the onBacktrack callback is evaluated.
    `void` | `onInitialize(MatchingFrame frame, ISearchContext context)` During the execution of the corresponding plan, the onInitialize callback is evaluated before the execution of the operation may begin.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.localsearch.operations.AbstractPositivePatternCallOperation

      `getVariablePositions`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ExtendPositivePatternCall

          public ExtendPositivePatternCall(MatcherReference calledQuery,
                                           java.util.Map<PParameter,java.lang.Integer> frameMapping)

      Since:
        1.5

  - ### Method Detail

    - #### onInitialize

          public void onInitialize(MatchingFrame frame,
                                   ISearchContext context)
                            throws LocalSearchException

      Description copied from interface: `ISearchOperation`
      During the execution of the corresponding plan, the onInitialize callback is evaluated before the execution of the operation may begin. Operations may use this method to initialize its internal data structures.
      Specified by:
        `onInitialize` in interface `ISearchOperation`
      Overrides:
        `onInitialize` in class `AbstractPositivePatternCallOperation`
      Throws:
        `LocalSearchException`

    - #### execute

          public boolean execute(MatchingFrame frame,
                                 ISearchContext context)
                          throws LocalSearchException

      Returns:
        true if successful, or false if backtracking needed
      Throws:
        `LocalSearchException`

    - #### onBacktrack

          public void onBacktrack(MatchingFrame frame,
                                  ISearchContext context)
                           throws LocalSearchException

      Description copied from interface: `ISearchOperation`
      After the execution of the operation failed and `ISearchOperation.execute(MatchingFrame, ISearchContext)` returns false, the onBacktrack callback is evaluated. Operations may use this method to clean up any temporary structures, and make the operation ready for a new execution.
      Throws:
        `LocalSearchException`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `AbstractPositivePatternCallOperation`